
// Variabili locali

public class Esempio1 {

	static int x;  // Variabile globale.

	public static void main(String[] args) {
		
		x = 10;
		if (x > 5) {
			int y; // Variabile locale.
			// Nota: qui non ci va "static" !
			
			// y viene creata solo quando (e se) si esegue il codice dentro l'if.
			// Ha una vita limitata al suo blocco { ... }, che ne definisce la sua
			// visibilità.
			
			y = x + 30;  // Si può usare y normalmente.
			System.out.println("y = " + y);
			
			// Quando si esce dal blocco, la y cessa di esistere.
		}
		
		// Qui y non è più visibile.
		// y = 30;  // Errore: y cannot be resolved to a variable

		if (x > 7) {
			boolean y; // Un'altra variabile locale.
			// Questa y non ha nessun legame con la y sopra: è indipendente.
			// Può anche avere tipo diverso, come si vede sopra.
			
			y = x == 10;
			System.out.println("y = " + y);
			
			// Quando si esce dal blocco, la nuova y cessa di esistere.
		}
		
		// Qui y non è più visibile.
		
		// In generale, si preferisce usare variabili locali piuttosto che
		// variabili globali. Questo perché:
		// 1) Si richiede la memoria necessaria per memorizzare y solo
		//    quando effettivamente serve, invece di richiederla per tutta
		//    la durata del programma.
		// 2) Se si modifica del codice già esistente, per esempio
		//       faiQualcosa;
		//       faiAltro;
		//    inserendo codice in mezzo, come in
		//       faiQualcosa;
		//       if (...) {
		//          int y; ....
		//       }
		//       faiAltro;
		//   siamo sicuri che la variabile y è totalmente indipendente
		//   dalle variabili usate da "faiQualcosa" e "faiAltro". Se usassimo
		//   una y globale, c'è il rischio che "faiQualosa" la imposti ad un
		//   valore con l'intento di eseguire "faiAltro" partendo da tale valore.
		//   Se il codice in mezzo modifica y, il programma smette di funzionare
		//   correttamente.	
		
		//   Le variabili globali in pratica vengono usate molto raramente.
		//   Uno dei pochi casi d'uso dove ha senso usare una variabile globale
		//   è lo Scanner per leggere l'input da tastiera.
		//   Questo perché ha senso che il canale di input dalla tastiera
		//   rimanga aperto per tutta la durata del programma.
		
		// Esercizio 1.
		// Dato n>=0, calcolate la somma a segni alternati
		//   0*0 - 1*1 + 2*2 - 3*3 + 4*4 .... n*n
		// Usate solo variabili locali.
		// Non usate l'operatore modulo a%b.
	}

}
