
// Procedure e funzioni

import java.util.Scanner;

public class Esempio2Sol {

	static Scanner tastiera;
	
	// Procedura definita dall'utente.
	// (In terminologia Java, viene anche chiamata "metodo")
	static void stampaSeparatore() {
		System.out.println("***********************");
		System.out.println("-----------------------");
		System.out.println("-----------------------");
		System.out.println("***********************");
	}
	
	// È anche possibile definire procedure che usano parametri.
	static void stampaQuadrato(int i) {
		// La i qui è una variabile locale.
		System.out.println("Il quadrato di " + i + " è " + (i*i));
	}

	// Questa procedura tenta di modificare il parametro
	static void nonModifica(int x) {
		// Qui stiamo modificando la variabile locale che
		// contiene il valore del parametro.
		x = 1000;
		// Ora x vale 1000, ma questo non ha effetti al di
		// fuori della procedura.
	}
	
	// Funzione definita dall'utente
	static int polinomio(int n) {
		// Qui si possono usare tutti i comandi desiderati, 
		// come nelle procedure.
		int m;
		m = n*n+2*n+4;
		// Risultato della funzione
		return m;
	}
	
	// Una funzione che usa una variabile globale.
	static int n = 0;
	static int strano(int m) {
		n++;
		return n + m;
	}
	
	static int cercaX(int a, int b, int y) {
		int x;
		for (x=a; x<=b; x++) {
			if (polinomio(x)==y) {
				return x;
			}
		}
		return x;  // O equivalentemente "return b+1;"
	}
	
	static int chiediInt(String msg) {
		System.out.println(msg);
		int x = tastiera.nextInt();
		return x;
	}
	
	public static void main(String[] args) {
		
		// Possiamo chiamare la procedura quante volte vogliamo.
		stampaSeparatore();
		System.out.println("#");
		stampaSeparatore();
		System.out.println("#");
		stampaSeparatore();

		// Chiamiamo la procedura stampaQuadrato tante volte, ogni
		// volta con un parametro diverso.
		int j;
		for (j=0 ; j<10 ; j++) {
			// Passo j come parametro
			stampaQuadrato(j);
		}
		
		// È possibile passare più parametri, separandoli con la virgola.
		// Per esempio,
		//    faiQualcosa(j, j+10, 10*j);
		// potrebbe chiamare una procedura
		//    static void faiQualcosa(int a, int b, int c);
	
		stampaSeparatore();
		j = 0;
		System.out.println("j = " + j);
		nonModifica(j);  // Questo NON modifica j
		System.out.println("j = " + j);
		// Qui sopra, il valore di j viene copiato nella variabile
		// x della procedura nonModifica, e poi x viene modificato.
		// Il valore di j è inalterato.
		
		stampaSeparatore();
		for (j=0 ; j<10 ; j++) {
			// Qui si può usare la funzione polinomio come una
			// normale funzione matematica.
			System.out.println("polinomio(" + j + ") = " + polinomio(j));
		}
		
		// Esercizio 1.
		// Osservate cosa succede se nel codice della funzione polinomio
		// si inserisce una println.
		
		// Esercizio 2.
		// Osservate cosa succede eseguendo il codice sotto, e datene una
		// giustificazione.
		stampaSeparatore();
		for (j=0 ; j<10 ; j++) {
			System.out.println("strano(42) = " + strano(42));
		}
		
		// Notate che quando viene usato il comando
		//    return ...;
		// in una funzione, questo interrompe immediatamente la sua
		// esecuzione, senza eseguire i comandi successivi. Per esempio,
		//    for (i=0 ; i<10 ; i++) {
		//       System.out.println(i);
		//       return 100+i;
		//    }
		// esegue una sola iterazione del for. Viene stampato solo "0",
		// perché la funzione è interrotta dal return. Il risultato della
		// funzione è 100.
		
		// Esercizio 3 parte 1.
		// Scrivete una funzione "cercaX" che, dati tre interi a, b, y con a<=b, 
		// restituisca il più piccolo x tra a e b tale per cui polinomio(x)=y.
		// Se non esiste un tale x, si restituisca b+1;
		
		// Esercizio 3 parte 2.
		// Per provare la funzione della prima parte, definite una nuova
		// funzione "chiediInt" per stampare un messaggio e chiedere
		// all'utente di inserire un intero da tastiera.
		// Fate in modo che nel main() si possa usare chiediInt così:
		//    int a;
		//    a = chiediInt("Inserisci il valore di a");
		//    int b;
		//    b = chiediInt("Inserisci il valore di b");
		//    int y;
		//    y = chiediInt("Inserisci il valore di y");
		// Dopo, sempre nel main(), chiamate cercaX(a,b,y) e stampate
		// la x corrispondente se esiste, o un messaggio che dice che
		// non esiste.

		tastiera = new Scanner(System.in);
		
		int a;
		a = chiediInt("Inserisci il valore di a");
		int b;
		b = chiediInt("Inserisci il valore di b");
		int y;
		y = chiediInt("Inserisci il valore di y");
		int x;
		x = cercaX(a, b, y);
		if (x != b+1) {
			System.out.println("x = " + x + " soddisfa polinomio(x) = " + y);
		} else {
			System.out.println("Nessuna x tra " + a + " e " + b + " soddisfa polinomio(x) = " + y);
		}
		
	}
}
